# F:=Rationals();
local result, l;
result:= rec();
result.comment:=
"A6 as 10 x 10 matrices over Z.\n\
Absolutely irreducible representation.\n\
Schur Index 1.\n\
\n\
SEED:\n\
Nonzero v negated by x and fixed by y^2*x*y^2*x*y*x*y\n\
where <x,y^2*x*y^2*x*y*x*y> = S4.\n\
v has 2 x 15 = 30 images under G; <v> has 15 images under G.\n\
BASIS:\n\
All in v^G (NSB([x,y,y^-1])+...).\n\
\n\
Possible matrix entries are in {-1,0,1}.\n\
\n\
Average number of nonzero entries for any element of the group:\n\
20  (20; 20% exactly).\n\
\n\
Entry  Av/Mat  %Av/Mat\n\
    0    80       80\n\
   1    20       20\n\
    1    10       10\n\
   -1    10       10\n\
";
result.symmetricforms:= [];
result.antisymmetricforms:= [];
result.hermitianforms:= [];
result.centralizeralgebra:= [];
result.generators:= List( [ [
-1,0,0,0,0,0,0,0,0,0,
0,0,0,1,0,0,0,0,0,0,
0,0,0,0,0,1,0,0,0,0,
0,1,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,1,0,0,
0,0,1,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,1,0,
0,0,0,0,1,0,0,0,0,0,
0,0,0,0,0,0,1,0,0,0,
0,0,0,0,0,0,0,0,0,-1]
,[
0,1,0,0,0,0,0,0,0,0,
0,0,0,0,1,0,0,0,0,0,
1,0,0,0,0,0,0,0,0,0,
1,-1,0,0,0,1,-1,0,0,0,
0,0,1,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,1,0,
0,1,0,0,-1,0,0,0,1,-1,
1,0,-1,1,0,0,0,0,1,0,
0,0,0,0,0,-1,0,0,0,0,
0,0,-1,0,1,-1,0,1,0,0]
], l -> List( [ 0 .. 9 ],
i -> l{ [ i*10+1 .. (i+1)*10 ] } ) );


l:= [
4,1,1,-1,0,-1,1,0,-1,0,
1,4,0,0,1,1,-1,0,-1,1,
1,0,4,1,1,-1,0,1,1,0,
-1,0,1,4,0,0,-1,1,-1,-1,
0,1,1,0,4,1,0,-1,1,-1,
-1,1,-1,0,1,4,1,1,0,0,
1,-1,0,-1,0,1,4,1,0,-1,
0,0,1,1,-1,1,1,4,0,1,
-1,-1,1,-1,1,0,0,0,4,1,
0,1,0,-1,-1,0,-1,1,1,4];
Add( result.symmetricforms, List( [ 0 .. 9 ],
i -> l{ [ i*10+1 .. (i+1)*10 ] } ) );


Add( result.centralizeralgebra, IdentityMat(10) );
return result;
